#!/bin/sh -eu

build_test_all() {
	local ALL_SHELLS shell
	readonly ALL_SHELLS='sh dash bash mksh ksh'

	cd "${0%/*}"

	for shell in ${ALL_SHELLS}; do
		if ! command -v "${shell}" > /dev/null; then
			printf -- 'Skipping non-existent shell "%s"\n' "${shell}"
			continue
		fi
		make distclean || true
		./configure --shell "${shell}"
		make
		echo '' | make test
		make checksums
		make distclean
	done
}

build_test_all
